package hideandseek.commands.admin;

import org.bukkit.entity.Player;
import org.bukkit.configuration.file.FileConfiguration;
import java.util.Iterator;
import org.bukkit.plugin.Plugin;
import java.sql.Statement;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.ChatColor;
import hideandseek.managers.FilesManager;
import java.sql.SQLException;
import hideandseek.Config;
import org.bukkit.Bukkit;
import hideandseek.PlayerData;
import org.bukkit.command.CommandSender;
import hideandseek.Customization;
import hideandseek.HideAndSeek;
import hideandseek.commands.SubCommand;

public class ResetCommand extends SubCommand
{
    public ResetCommand() {
        super("hideandseek.reset", true, "<Player> | All");
    }
    
    public boolean execute(final HideAndSeek var1, final Customization var2, final CommandSender var3, final String[] var4) {
        if (var4.length == 1) {
            return false;
        }
        if (var4[1].equalsIgnoreCase("all")) {
            for (final String var6 : var1.playerData.keySet()) {
                final PlayerData var7 = var1.playerData.get(var6);
                final Player var8 = Bukkit.getPlayer(var6);
                var7.reset(var8);
            }
            if (Config.getInstance().mysql_enabled) {
                try {
                    var1.mysql.getConnection().createStatement().executeUpdate("delete from " + var1.mysql.tableName);
                }
                catch (final SQLException var9) {
                    var9.printStackTrace();
                }
            }
            else {
                FilesManager.getInstance().getConfig("players.yml").set("Players", (Object)null);
                FilesManager.getInstance().saveConfig("players.yml");
            }
            Bukkit.broadcastMessage((String)var2.messages.get("stats_reset"));
            var3.sendMessage(var2.prefix + String.valueOf(ChatColor.GREEN) + "成功!" + String.valueOf(ChatColor.GOLD) + " 所有玩家的统计信息已被重置!");
        }
        else {
            final Player var10 = Bukkit.getPlayer(var4[1]);
            if (var10 != null) {
                var1.playerData.get(var10.getName()).reset(var10);
                var10.sendMessage((String)var2.messages.get("stats_reset"));
                var3.sendMessage(var2.prefix + String.valueOf(ChatColor.GREEN) + "成功!" + String.valueOf(ChatColor.YELLOW) + " " + var10.getName() + String.valueOf(ChatColor.GOLD) + " 的统计信息已被重置!");
            }
            else {
                var3.sendMessage(var2.prefix + String.valueOf(ChatColor.YELLOW) + "无法找到对应的在线玩家, 正在查找数据库...");
                final long var11 = System.currentTimeMillis();
                final String var12 = var4[1];
                if (Config.getInstance().mysql_enabled) {
                    new BukkitRunnable() {
                        public void run() {
                            try {
                                final Statement var1x = var1.mysql.getConnection().createStatement();
                                if (var1x.executeQuery("select * from " + var1.mysql.tableName + " where player_name='" + var12).next()) {
                                    var1.mysql.getConnection().prepareStatement("delete from " + var1.mysql.tableName + " WHERE player_name= '" + var12 + "';").executeUpdate();
                                    final long var2x = System.currentTimeMillis() - var11;
                                    var3.sendMessage(var2.prefix + "玩家" + String.valueOf(ChatColor.YELLOW) + var12 + String.valueOf(ChatColor.GOLD) + " 的数据已被抹除！消耗了" + String.valueOf(ChatColor.LIGHT_PURPLE) + var2x + "ms " + String.valueOf(ChatColor.GOLD) + "(" + String.valueOf(ChatColor.AQUA) + var2x / 1000L + "s" + String.valueOf(ChatColor.GOLD) + ") 来寻找玩家数据");
                                }
                                else {
                                    var3.sendMessage((String)var2.messages.get("no_player_found"));
                                }
                            }
                            catch (final SQLException var4) {
                                var4.printStackTrace();
                            }
                        }
                    }.runTaskAsynchronously((Plugin)var1);
                }
                else {
                    final FileConfiguration var13 = FilesManager.getInstance().getConfig("players.yml");
                    if (var13.getConfigurationSection("Players") == null || var13.getConfigurationSection("Players").getKeys(false).isEmpty()) {
                        var3.sendMessage((String)var2.messages.get("no_player_found"));
                        return true;
                    }
                    new BukkitRunnable() {
                        final Iterator<String> players = val$var9.getConfigurationSection("Players").getKeys(false).iterator();
                        boolean found = false;
                        
                        public void run() {
                            int var1 = 0;
                            while (var1 < 300 && this.players.hasNext()) {
                                ++var1;
                                final String var2x = this.players.next();
                                final String var3x = var13.getString("Players." + var2x + ".Name");
                                if (var3x.equalsIgnoreCase(var12)) {
                                    var13.set("Players." + var2x, (Object)null);
                                    FilesManager.getInstance().saveConfig("players.yml");
                                    final long var2 = System.currentTimeMillis() - var11;
                                    var3.sendMessage(var2.prefix + "玩家 " + String.valueOf(ChatColor.YELLOW) + var3x + String.valueOf(ChatColor.GOLD) + " 的数据已被抹除！消耗了" + String.valueOf(ChatColor.LIGHT_PURPLE) + var2 + "ms " + String.valueOf(ChatColor.GOLD) + "(" + String.valueOf(ChatColor.AQUA) + var2 / 1000L + "s" + String.valueOf(ChatColor.GOLD) + ") 来查找玩家数据");
                                    this.found = true;
                                    this.cancel();
                                    break;
                                }
                            }
                            if (!this.players.hasNext() && !this.found) {
                                var3.sendMessage((String)var2.messages.get("no_player_found"));
                                this.cancel();
                            }
                        }
                    }.runTaskTimerAsynchronously((Plugin)var1, 0L, 1L);
                }
            }
        }
        return true;
    }
}
